/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_URL_H
#define _UDM_URL_H

#define UDM_URL_CANONIZE_MULTIPLY 3

UDM_API(void) UdmURLInit(UDM_URL *url);
UDM_API(void) UdmURLFree(UDM_URL *url);
udm_rc_t UdmURLParse(UDM_URL *url,const char *s);
const char *UdmURLErrorStr(udm_rc_t rc);
char * UdmURLNormalizePath(char * path);
size_t UdmURLCanonize(const char *src, char *dst, size_t dstsize);
size_t UdmURLCanonizePath(char *dst, size_t dstsize, const char *src);
size_t UdmAbsoluteURLSiteLength(const char *str);

void UdmURLListInit(UDM_URLLIST *L);
void UdmURLListFree(UDM_URLLIST *L);
udm_rc_t UdmURLListAdd(UDM_URLLIST *L, const UDM_URL *url);
udm_rc_t UdmURLListCopy(UDM_URLLIST *dst, const UDM_URLLIST *src);

/* Functions from idn.c */
size_t UdmIDNEncode(UDM_CHARSET *cs, const char *src, char *dst, size_t dstlen);
size_t UdmIDNDecode(UDM_CHARSET *cs, const char *src, char *dst, size_t dstlen);

#endif

